Subject: RE: The power of OCP

From: "Martin Stecher" <[email-masked]>
Date: Tue, 1 Jul 2003 08:52:00 +0200

> 
> > I do not think right now that exchanging this data or even
> > negotiating on this will really change something. A processor may or
> > may not have limitation for its data preservation capabilities.
> > Preferences of the callout server will probably not change anything
> > here. Callout servers may like to make intensive use from preserved
> > data but be definition need to be prepared that the processor stops
> > to preserve more data; it has to handle that anyway. No need for a
> > special announcement I guess; it won't change the algorithm I guess.
> >
> > Am I missing something? Do you know of examples where exhanging of
> > that information will make a difference?
> 
> A translation service will not use any of the data. An ad banner
> stripping service will use all but the prefix data. The virus filter
> service will use all the data. Ideally, the processor should not keep
> 5MB file to be translated but should keep the 5MB file being filtered.
> How does the processor distinguish among these cases? Should the
> processor assume that most data will be re-requested and preserve
> aggressively until it receives a Wont-Use message?
> 

Both examples will handle data chunk wise, the processor will already receive some response before having sent the majority of data.
With Wont-Use and modp we have already mechanism in place to inform the processor that further data preservation may not be needed.
But I think a processor should start to preserve data as good as it can before it receives a response.
If you want to make a processor extra smart you may want to learn from transaction responses; if none uses the preserved data, it could stop copying it.

Does this sound good enough for you or do you (still) think we need to negotiate preservation preferences before the first transaction starts?

Martin

---

From: Alex Rousskov <[email-masked]>
Date: Tue, 1 Jul 2003 09:23:48 -0600 (MDT)

On Tue, 1 Jul 2003, Martin Stecher wrote:

> > > negotiating on this will really change something. A processor
> > > may or may not have limitation for its data preservation
> > > capabilities. Preferences of the callout server will probably
> > > not change anything here. Callout servers may like to make
> > > intensive use from preserved data but be definition need to be
> > > prepared that the processor stops to preserve more data; it has
> > > to handle that anyway. No need for a special announcement I
> > > guess; it won't change the algorithm I guess.
> > >
> > > Am I missing something? Do you know of examples where exhanging
> > > of that information will make a difference?
> >
> > stripping service will use all but the prefix data. The virus
> > filter service will use all the data. Ideally, the processor
> > should not keep 5MB file to be translated but should keep the 5MB
> > file being filtered. How does the processor distinguish among
> > these cases? Should the processor assume that most data will be
> > re-requested and preserve aggressively until it receives a
> > Wont-Use message?
> >
>
> Both examples will handle data chunk wise, the processor will
> already receive some response before having sent the majority of
> data. With Wont-Use and modp we have already mechanism in place to
> inform the processor that further data preservation may not be
> needed. But I think a processor should start to preserve data as
> good as it can before it receives a response. If you want to make a
> processor extra smart you may want to learn from transaction
> responses; if none uses the preserved data, it could stop copying
> it.
>
> Does this sound good enough for you or do you (still) think we need
> to negotiate preservation preferences before the first transaction
> starts?

I did no mean to suggest that preservation preferences must be
negotiated, I only meant to question whether they should be. You asked
for an example where it may make a difference, and I tried to come up
with one.

My feeling is that implementations would want to negotiate
preservation in some environments, especially when both the processor
and the server are controlled/developed by the same entity. Clearly,
one can optimize processor resources if there is a way for the server
to tell the processor what exactly needs to be preserved. On the other
hand, there may not be a simple generic way to do that.

We can leave the issue unaddressed and hope that popular extensions
(if any) would be documented/standardized. No changes are required
until somebody insists on them.

Alex.